
#property copyright "Scritong"
#property link      "http://autograf.dp.ua"

//---- input parameters
extern string    A1 = " .  Lots = 0,    ";
extern double    Lots = 0.01;
extern double    PercentOfDepo = 5;
extern string    A2 = " ";

extern int  dist2           = 21;
extern int  dist1           = 14;
extern bool alertsOn        = true;
extern bool alertsOnCurrent = true;
extern bool alertsMessage   = true;
extern bool alertsSound     = true;
extern bool alertsEmail     = false;                                                   //    ..
                                                   // .. 
extern string    A3 = "==   - ===";
extern string    A4 = "True -   , false -  ";
extern bool      UseSLInPoints = false;
extern string    A5 = "  (  )";
extern double    StopLoss = 5;
extern string    A6 = " ATR,     ";
extern int       SLATR = 24;
extern string    A7 = "==    ===";
extern string    A8 = "True -   , false -  ";
extern bool      UseTPInPoints = false;
extern string    A9 = "  (  )";
extern double    TakeProfit = 1;
extern string    A10 = " ATR,     ";
extern int       TPATR = 24;
extern string    A11 = "===   ===";
extern string    OpenOrderSound = "ok.wav";
extern int       MagicNumber = 100345;

int Signal,                                        //  
    Ticket,                                        //   
    Type;                                          //   

bool Activate, FreeMarginAlert, FatalError;
double Tick, Spread, StopLevel, MinLot, MaxLot, LotStep, FreezeLevel;
datetime LastBar, LastSignal;

//+-------------------------------------------------------------------------------------+
//|                                                         |
//+-------------------------------------------------------------------------------------+
int init()
{
   FatalError = False;
// - 1 - ==      ========================================   
   Tick = MarketInfo(Symbol(), MODE_TICKSIZE);                         //      
   Spread = ND(MarketInfo(Symbol(), MODE_SPREAD)*Point);                 //  
   StopLevel = ND(MarketInfo(Symbol(), MODE_STOPLEVEL)*Point);  //   
   FreezeLevel = ND(MarketInfo(Symbol(), MODE_FREEZELEVEL)*Point);   //  
   MinLot = MarketInfo(Symbol(), MODE_MINLOT);    //    
   MaxLot = MarketInfo(Symbol(), MODE_MAXLOT);   //    
   LotStep = MarketInfo(Symbol(), MODE_LOTSTEP);          //    
// - 1 - ==   =============================================================

// - 3 - =================     =====================
   if (StopLoss < 0)
   {
      Alert(" StopLoss    .   .");
      return(0);
   }
   if (TakeProfit < 0)
   {
      Alert(" TakeProfit    .   .");
      return(0);
   }
   if (SLATR < 2)
   {
      Alert(" SLATR     2.   .");
      return(0);
   }
   if (TPATR < 2)
   {
      Alert(" TPATR     2.   .");
      return(0);
   }
// - 3 - ===========================   ====================================
   
   LastBar = 0;
   LastSignal = 0;
   Activate = True; //    ,    
   
//----
   return(0);
}
  
//+-------------------------------------------------------------------------------------+
//|                                                         |
//+-------------------------------------------------------------------------------------+
int deinit()
{
   return(0);
}
  
//+-------------------------------------------------------------------------------------+
//|   ,    .                                  |
//+-------------------------------------------------------------------------------------+
double GetLots()
{
   if (Lots == 0)                                  //   Lots  , 
   {                                               // ..   ..
                                                   // .. 
      double lot = (PercentOfDepo/100)*AccountFreeMargin()/
                                   MarketInfo(Symbol(), MODE_MARGINREQUIRED);
      return(LotRound(lot));
   }
   else                                            //     , ..
      return(LotRound(Lots));                      // ..   
}

//+-------------------------------------------------------------------------------------+
//|                                              |
//+-------------------------------------------------------------------------------------+
double LotRound(double L)
{
   return(MathRound(MathMin(MathMax(L, MinLot), MaxLot)/LotStep)*LotStep);
}

//+-------------------------------------------------------------------------------------+
//|                                              |
//+-------------------------------------------------------------------------------------+
double ND(double A)
{
   return(NormalizeDouble(A, Digits));
}  

//+-------------------------------------------------------------------------------------+
//|                                                         |
//+-------------------------------------------------------------------------------------+
string ErrorToString(int Error)
{
   switch(Error)
   {
      case 2: return("  ,   ."); 
      case 5: return("    ,  ."); 
      case 6: return("   ,   ."); 
      case 64: return(" ,   .");
      case 132: return(" ."); 
      case 133: return(" ."); 
      case 149: return(" ."); 
   }
}

//+-------------------------------------------------------------------------------------+
//|   .   ,   True,  - False    |
//+-------------------------------------------------------------------------------------+  
bool WaitForTradeContext()
{
   int P = 0;
   while(IsTradeContextBusy() && P < 5)
   {
      P++;
      Sleep(1000);
   }
   if (P == 5)
     return(False);
   return(True);    
}

//+-------------------------------------------------------------------------------------+
//| ""                                                         |
//|    OpenOrder            |
//| :                                                                         |
//|   0 -                                                                      |
//|   1 -                                                                 |
//|   2 -   Price                                                         |
//|   3 -   SL                                                            |
//|   4 -   TP                                                            |
//|   5 -   Lot                                                           |
//+-------------------------------------------------------------------------------------+
int OpenOrderCorrect(int Type, double Lot, double Price, double SL, double TP, 
                     bool Redefinition = True)
// Redefinition -  True     
//                 False -  
{
// - 1 - ==     ====================================
 if(AccountFreeMarginCheck(Symbol(), OP_BUY, Lot) <= 0 || GetLastError() == 134) 
  {
   if(!FreeMarginAlert)
    {
     Print("    . Free Margin = ", 
           AccountFreeMargin());
     FreeMarginAlert = True;
    } 
   return(5);  
  }
 FreeMarginAlert = False;  
// - 1 - ==   =============================================================

// - 2 - ==   Price, SL  TP    ====================   
 RefreshRates();
 switch (Type)
   {
    case OP_BUY: 
                string S = "BUY"; 
                if (MathAbs(Price-Ask)/Point > 3)
                  if (Redefinition) Price = ND(Ask);
                  else              return(2);
                if (ND(TP-Bid) <= StopLevel && TP != 0)
                  if (Redefinition) TP = ND(Bid+StopLevel+Tick);
                  else              return(4);
                if (ND(Bid-SL) <= StopLevel)
                  if (Redefinition) SL = ND(Bid-StopLevel-Tick);
                  else              return(3);
                break;
    case OP_SELL: 
                 S = "SELL"; 
                 if (MathAbs(Price-Bid)/Point > 3)
                   if (Redefinition) Price = ND(Bid);
                   else              return(2);
                 if (ND(Ask-TP) <= StopLevel) 
                   if (Redefinition) TP = ND(Ask-StopLevel-Tick);
                   else              return(4);
                 if (ND(SL-Ask) <= StopLevel && SL != 0)
                   if (Redefinition) SL = ND(Ask+StopLevel+Tick);
                   else              return(3);
                 break;
    case OP_BUYSTOP: 
                    S = "BUYSTOP";
                    if (ND(Price-Ask) <= StopLevel)
                      if (Redefinition) Price = ND(Ask+StopLevel+Tick);
                      else              return(2);
                    if (ND(TP-Price) <= StopLevel && TP != 0)
                      if (Redefinition) TP = ND(Price+StopLevel+Tick);
                      else              return(4);
                    if (ND(Price-SL) <= StopLevel)
                      if (Redefinition) SL = ND(Price-StopLevel-Tick);
                      else              return(3);
                    break;
    case OP_SELLSTOP: 
                     S = "SELLSTOP";
                     if (ND(Bid-Price) <= StopLevel)
                       if (Redefinition) Price = ND(Bid-StopLevel-Tick);
                       else              return(2);
                     if (ND(Price-TP) <= StopLevel)
                       if (Redefinition) TP = ND(Price-StopLevel-Tick);
                       else              return(4);
                     if (ND(SL-Price) <= StopLevel && SL != 0)
                       if (Redefinition) SL = ND(Price+StopLevel+Tick);
                       else              return(3);
                     break;
    case OP_BUYLIMIT: 
                     S = "BUYLIMIT";
                     if (ND(Ask-Price) <= StopLevel)
                      if (Redefinition) Price = ND(Ask-StopLevel-Tick);
                      else              return(2);
                     if (ND(TP-Price) <= StopLevel && TP != 0)
                       if (Redefinition) TP = ND(Price+StopLevel+Tick);
                       else              return(4);
                     if (ND(Price-SL) <= StopLevel)
                       if (Redefinition) SL = ND(Price-StopLevel-Tick);
                       else              return(3);
                     break;
    case OP_SELLLIMIT: 
                     S = "SELLLIMIT";
                     if (ND(Price - Bid) <= StopLevel) 
                       if (Redefinition) Price = ND(Bid+StopLevel+Tick);
                       else              return(2);
                     if (ND(Price-TP) <= StopLevel)
                       if (Redefinition) TP = ND(Price-StopLevel-Tick);
                       else              return(4);
                     if (ND(SL-Price) <= StopLevel && SL != 0)
                       if (Redefinition) SL = ND(Price+StopLevel+Tick);
                       else              return(3);
                     break;
   }
// - 2 - ==   =============================================================
 
// - 3 - ==       =================================   
 if(WaitForTradeContext())  //    
   {  
    Comment("     ", S, " ...");  
    int ticket=OrderSend(Symbol(), Type, Lot, Price, 3, 
               SL, TP, NULL, MagicNumber, 0);//  
    //     
    if(ticket<0)
      {
       int Error = GetLastError();
       if(Error == 2 || Error == 5 || Error == 6 || Error == 64 
          || Error == 132 || Error == 133 || Error == 149)     //   
         {
          Comment("     . . "+
                   ErrorToString(Error)+"  !");
          FatalError = True;
         }
        else 
         Comment("   ", S, ": ", Error);       //  
       return(1);
      }
    // ---------------------------------------------
    
    //      
    Comment(" ", S, "  !"); 
    PlaySound(OpenOrderSound); 
    return(0); 
    // ------------------------
   }
  else
   {
    Comment("     !");
    return(1);  
   } 
// - 3 - ==   ============================================================= 
}

//+-------------------------------------------------------------------------------------+
//|                                                |
//+-------------------------------------------------------------------------------------+
double NP(double A)
{
   return(MathRound(A/Tick)*Tick);
}  

//+-------------------------------------------------------------------------------------+
//|                           |
//+-------------------------------------------------------------------------------------+
void GetSignal()
{
   Signal = 0;
 
// - 1 - ==    ==============================================
double up_sig = iCustom(NULL, 0, "Super Signal v3d", dist2, dist1, alertsOn, alertsOnCurrent, alertsMessage, alertsSound, alertsEmail, 2, 1);
double dn_sig = iCustom(NULL, 0, "Super Signal v3d", dist2, dist1, alertsOn, alertsOnCurrent, alertsMessage, alertsSound, alertsEmail, 3, 1);                                                   
//    ..
                                                   // .. -  iCustom
// - 1 - ==   =============================================================

// - 2 - ==    ===================================================
if (up_sig != EMPTY_VALUE)                                                    //    ..
                                                   // .. 
      Signal = 1;                                                         
// - 2 - ==   =============================================================

// - 3 - ========================    =============================
if (dn_sig != EMPTY_VALUE)                                                   //    ..
                                                   // .. 
      Signal = -1;                                                         
// - 3 - ==   =============================================================
}
//+-------------------------------------------------------------------------------------+
//|    .                                                       |
//+-------------------------------------------------------------------------------------+
void FindOrders()
{
// - 1 - ==     ======================================
   int total = OrdersTotal() - 1;
   Ticket = -1;
   Type = -1;
// - 1 - ==   =============================================================
 
// - 2 - ==   =======================================================
   for (int i = total; i >= 0; i--)                //    
      if (OrderSelect(i, SELECT_BY_POS))           // ,   
         if (OrderMagicNumber() == MagicNumber &&  //   , 
             OrderSymbol() == Symbol() &&          // ..   
             OrderType() < 2)
         {
            Ticket = OrderTicket();                //   
            Type = OrderType();
         } 
// - 2 - ==   =============================================================
}
//+-------------------------------------------------------------------------------------+
//|                                                     |
//+-------------------------------------------------------------------------------------+
bool CloseDeal(int ticket) 
{                          
   if (OrderSelect(ticket, SELECT_BY_TICKET) &&    //    .. 
       OrderCloseTime() == 0)                      // ..    
      if (WaitForTradeContext())                   //    ?
      {
         if (OrderType() == OP_BUY)                //    .. 
            double Price = MarketInfo(Symbol(), MODE_BID);// ..,  ..
                                                   // .. BID
         else                                      //    .. 
            Price = MarketInfo(Symbol(), MODE_ASK);// ..,    ASK
         if (!OrderClose(OrderTicket(), OrderLots(), NP(Price), 3))//   ..
            return(False);                         // .. ,  ..
                                                   //  - False
      }    
      else
         return(false);
   return(True);                                   //    
}     
//+-------------------------------------------------------------------------------------+
//|                                              |
//+-------------------------------------------------------------------------------------+
double GetLevel(bool in_points, double value, int atr_period, double price, int koef)
{
   if (value == 0)                                 //     ,
      return(0);                                   // ..   
   if (in_points)                                  //     
      return(NP(price + koef*value));              //  ,   
                                                   // ..  value  ..
                                                   // .. koef
   return(NP(price + koef*value*                   //    ..
          iATR(NULL, 0, atr_period, 1)));          // ...  ..
                                                   // ..,    
                                                   // ..price  value  
                                                   // .. koef
}
//+-------------------------------------------------------------------------------------+
//|                                                                      |
//+-------------------------------------------------------------------------------------+
bool Trade()
{
   FindOrders();                                   //   
// - 1 - ==    ====================================================
   if (Signal > 0 && Type != OP_BUY)               //    ..
   {                                               // ..  
      if (Type == OP_SELL)                         //   
         if (!CloseDeal(Ticket))                   //  
            return(false);                         //    false
      double sl = GetLevel(UseSLInPoints, StopLoss,//   - ..
                           SLATR, Ask, -1);
      double tp = GetLevel(UseSLInPoints, StopLoss, SLATR, Ask, 1); // ..
      if (OpenOrderCorrect(OP_BUY, GetLots(), NP(Ask), sl, tp) != 0)
         return(False);                    
   }       
// - 1 - ==   =============================================================
           
// - 2 - ==    ===================================================
   if (Signal < 0 && Type != OP_SELL)              //    ..
   {                                               // ..  
      if (Type == OP_BUY)                          //   
         if (!CloseDeal(Ticket))                   //  
            return(false);                         //    false
      sl = GetLevel(UseSLInPoints, StopLoss, SLATR,//   - ..
                    Bid, 1);
      tp = GetLevel(UseSLInPoints, StopLoss, SLATR, Bid, -1);// ..
      if (OpenOrderCorrect(OP_SELL, GetLots(), NP(Bid), sl, tp) != 0)
         return(False);                    
   }       
// - 2 - ==   =============================================================
   return(True);    
}

//+-------------------------------------------------------------------------------------+
//|  start                                                               |
//+-------------------------------------------------------------------------------------+
int start()
{
// - 1 - ==    ? =================================================
   if (!Activate || FatalError) return(0);
// - 1 - ==   =============================================================

// - 2 - ==     ===============================================
   if (LastBar == Time[0])                         //      ..
      return(0);                                   // ..  ,
                                                   // ..   ..
                                                   // .. 
// - 2 - ==   =============================================================

// - 3 - ==      ==================================
   if (!IsTesting())
   {
      Tick = MarketInfo(Symbol(), MODE_TICKSIZE);  //      
      Spread = ND(MarketInfo(Symbol(), MODE_SPREAD)*Point);//  
      StopLevel = ND(MarketInfo(Symbol(), MODE_STOPLEVEL)*Point);//  
      FreezeLevel = ND(MarketInfo(Symbol(), MODE_FREEZELEVEL)*Point);//  
   } 
// - 3 - ==   =============================================================

// - 4 - ==   =============================================================
   if (LastSignal != Time[0])                      //      ..
   {                                               // ..  
      GetSignal();                                 //   
      LastSignal = Time[0];                        //     
   }                                               // ..
// - 4 - ==   =============================================================
   
// - 5 - ==    ================================================
   if (Signal != 0)                                //   
      if (!Trade()) return(0);                     // / 
// - 5 - ==   =============================================================

   LastBar = Time[0];

   return(0);
}

